#include "def.h"
Geometry Cylinder;
DMDACoor3d    ***coors;
// -- _Flag and _NodeV: '_' before the name indicates this is an ARRAY of STRUCTURE defined by Alan OR it has the similar name of structure name
Flag ***_Flag;
ForcingTerm ***_Ft;
NodeV ***_NodeV, **_NodeVArray, *_NodeValues;
//NodePrimV ***_NodePrimV, **_NodePrimVArray, *_NodePrimValues;
NodeIndex _Index;
LocalBC localBC;
StaggerGrid ***_SG;
double PhyX[imax+1], PhyY[jmax+1], PhyZ[kmax+1];
double PhyDx[imax+1], PhyDy[jmax+1], PhyDz[kmax+1];
double GLeftX[xg+xb+1], GRightX[xg+xb+1], GBotY[yg+yb+1], GTopY[yg+yb+1], GAftZ[zg+zb+1], GFrontZ[zg+zb+1];
double GLeftDx, GRightDx, GBotDy, GTopDy, GAftDz, GFrontDz;

double *uDx, *vDx, *wDx, *pDx;
double *uDy, *vDy, *wDy, *pDy;
double *uDz, *vDz, *wDz, *pDz;

double cntx, cnty, cntz;


// -- 0.1 -- Finished

// -- 0.2 -- "ComputerFunctions" Global Variables
char fname[30];
//// vgi, vgj: i, j for neighbor/vicinity area
int i, j, k, h, vgi, vgj, vgk, crclnm;
int mx, my, mz, xw, yw, zw, xs, ys, zs, mm, nn, pp, rank, xc, yc, zc, xm, ym, zm;
int NumRank;
//// mx: global length of x; 
//// xs: local starting point of x in DM da;
//// xw: local width of x in DM da;
//// xc: local width of computational nodes;
// -- 0.2 -- Finished

// -- 0.3 -- "Communication"
NeighborRank NbrRank;
MPI_Datatype rowtype, spantype;
MPI_Datatype columntype;
MPI_Datatype structype;
int rowsize, columnsize, spansize;

